#include "updown.c"
#include "textbox.c"

var total_questions=0;
var total_points=0;
var cur_index=0;

//monkey puzzle questions
//with 4 possible answers(option1 to option4)
//correct_answer being the answer to the question(one of the options)
//points earned for answering correct
typedef struct{
	STRING* question;//question
	STRING* option1;//answer option1
	STRING* option2;//answer option2
	STRING* option3;//answer option3
	var correct_answer;//the correct answer option is (1 2 3 4)?
	var points;
}questions;

questions *quiz;

void set_total_questions(var total)
{
	quiz=malloc(sizeof(questions)*total);
	memset(quiz,NULL,sizeof(quiz));
	total_questions=total;
}

void add_question(STRING* q,STRING* op1,STRING *op2,STRING* op3,int correctval,int pointval)
{
	quiz[cur_index].question=q;
	quiz[cur_index].option1=op1;
	quiz[cur_index].option2=op2;
	quiz[cur_index].option3=op3;
	quiz[cur_index].correct_answer=correctval;
	quiz[cur_index].points=pointval;
}

void load_file(char* name)
{
	int i;
	cur_index=0;
	//loadfile
	var file=file_open_read(name);
	//read total quests
	int tot=file_var_read(file);
	//alloc size
	set_total_questions(tot);
	for(i=0;i<tot;i++)
	{
		STRING *qt=str_create("");
		STRING *a=str_create("");
		STRING *b=str_create("");
		STRING *c=str_create("");
		int cor=0;
		int p=0;
		//read index
		//int index=file_var_read(file);
		//read question
		file_str_read(file,qt);
		//read options
		file_str_read(file,a);
		file_str_read(file,b);
		file_str_read(file,c);
		//read correct answer
		cor=file_var_read(file);
		//read points
		p=file_var_read(file);
		//add question data
		cur_index=i;

		add_question(qt,a,b,c,cor,p);
	}
	file_close(file);
}

void save_file(char* name,int retnum)
{
	int i;
	cur_index=0;
	//save file
	var file=file_open_write("quiz.txt");
	file_var_write(file,retnum);
	//file_str_write(file,",");
	for(i=0;i<retnum;i++)
	{
		//file_var_write(file,i);
		//file_str_write(file,",");
		file_str_write(file,quiz[i].question);
		file_str_write(file,str_printf(NULL,","));
		file_str_write(file,quiz[i].option1);
		file_str_write(file,str_printf(NULL,","));
		file_str_write(file,quiz[i].option2);
		file_str_write(file,str_printf(NULL,","));
		file_str_write(file,quiz[i].option3);
		file_str_write(file,str_printf(NULL,","));
		file_var_write(file,quiz[i].correct_answer);
		//file_str_write(file,str_printf(NULL,","));
		file_var_write(file,quiz[i].points);
		//file_str_write(file,",");
	}
	file_close(file);
}
int get_total_questions()
{
	return total_questions;
}
int lstpoints=0;
int get_lastpoints()
{
	return lstpoints;
}
int do_question(int index)
{
	//read question
	lstpoints=0;
	STRING* question=quiz[index].question;
	STRING* op1=quiz[index].option1;
	STRING* op2=quiz[index].option2;
	STRING* op3=quiz[index].option3;
	int cor=quiz[index].correct_answer;
	int pts=quiz[index].points;
	int done=0;
	int answercorrect=0;
	while(!done)
	{
		//display question and options
		draw_text(question,0,80,COLOR_WHITE);
		draw_text(str_printf(NULL,"is it (1)"),0,100,COLOR_WHITE);
		draw_text(op1,80,100,COLOR_WHITE);
		draw_text(str_printf(NULL,"is it (2)"),0,120,COLOR_WHITE);
		draw_text(op2,80,120,COLOR_WHITE);
		draw_text(str_printf(NULL,"is it (3)"),0,140,COLOR_WHITE);
		draw_text(op3,80,140,COLOR_WHITE);
		draw_text(str_printf(NULL,"for points %d",pts),0,160,COLOR_WHITE);
		
		if(key_1)
		{
			if(cor==1)lstpoints=pts;
			else lstpoints=0;
			done=1;
		}
		if(key_2)
		{
			if(cor==2)lstpoints=pts;
			else lstpoints=0;
			done=1;
		}
		if(key_3)
		{
			if(cor==3)lstpoints=pts;
			else lstpoints=0;
			done=1;
		}
		wait(1);
	}
	if(lstpoints<1)
	{
		PANEL* wrong=pan_create("bmap=wrong.bmp",101);
		wrong.pos_x=400;
		wrong.pos_y=300;
		wrong.flags=OVERLAY|SHOW;
		wait(-2);
		ptr_remove(wrong);
	}
}

void create_quiz()
{
	//ask how many questions
	//max=50
	create_updown_controll(50,50,"how many questions would you like to add",50);
	wait_for(create_updown_controll);

	//alloc size
	int retnum=getupdownval();
	if(retnum>0)//not cancelled
	{
		set_total_questions(retnum);
		int i;
		for(i=0;i<retnum;i++)//loop through all questions
		{
			create_textbox(50,50,"enter text for question");
			wait_for(create_textbox);
			STRING* queststr=get_textbox_str();
			if(str_cmp(queststr,"NOTHING DONE")) break;//cancelled

			//go through options
			create_textbox(50,50,"enter text for answer 1");
			wait_for(create_textbox);
			STRING *a1=get_textbox_str();
			if(str_cmp(a1,"NOTHING DONE")) break;//cancelled

			create_textbox(50,50,"enter text for answer 2");
			wait_for(create_textbox);
			STRING *a2=get_textbox_str();
			if(str_cmp(a2,"NOTHING DONE")) break;//cancelled

			create_textbox(50,50,"enter text for answer 3");
			wait_for(create_textbox);
			STRING *a3=get_textbox_str();
			if(str_cmp(a3,"NOTHING DONE")) break;//cancelled
			
			create_updown_controll(50,50,"enter the correct answer number for the question(1 to 3)",3);
			wait_for(create_updown_controll);
			int correctanswer=getupdownval();
			if(correctanswer<1)break;//cancelled

			create_updown_controll(50,50,"enter the points for this question(1 to whatever)",50000);
			wait_for(create_updown_controll);
			int pointsforq=getupdownval();
			if(pointsforq<1)break;//cancelled
			
			cur_index=i;
			add_question(queststr,a1,a2,a3,correctanswer,pointsforq);
		}
		if(cur_index==retnum-1)//all things were done
		{
			save_file("quiz.txt",retnum);
		}
	}
}

